'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _class;

// Available API endpoints


var _request = require('request');

var _request2 = _interopRequireDefault(_request);

var _checkTypes = require('check-types');

var _checkTypes2 = _interopRequireDefault(_checkTypes);

var _assign_params = require('./utils/assign_params');

var _assign_params2 = _interopRequireDefault(_assign_params);

var _constants2 = require('./config/constants');

var _constants3 = _interopRequireDefault(_constants2);

var _geocode2 = require('./geocode');

var _geocode3 = _interopRequireDefault(_geocode2);

var _matrix_routing = require('./matrix_routing');

var _matrix_routing2 = _interopRequireDefault(_matrix_routing);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ACCEPTED_CONFIG_KEYS = _constants3.default.ACCEPTED_CONFIG_KEYS;

var HereMapsAPI = (0, _geocode3.default)(_class = (0, _matrix_routing2.default)(_class = function HereMapsAPI(config, request) {
  _classCallCheck(this, HereMapsAPI);

  this.config = _initConfig(config);
  this.request = _initRequest(request);
}) || _class) || _class;

exports.default = HereMapsAPI;


function _initConfig(config) {
  if (!_checkTypes2.default.object(config)) {
    config = {};
  }

  return (0, _assign_params2.default)({}, config, ACCEPTED_CONFIG_KEYS);
}

function _initRequest(request) {
  if (typeof request !== 'function') {
    return _request2.default;
  }

  return request;
}